<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Scopes/Synopsis/SymbolLookup/Scope.html -->
<!-- this view was generated by Scope -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis::SymbolLookup::Scope</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Scope">
<div class="navigation">
<span class="normal"><a href="../../global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
<!-- this part was generated by Heading -->
<div class="class-module">namespace <a href="../../Synopsis.html" >Synopsis</a>::<a href="../SymbolLookup.html" >SymbolLookup</a>
</div><div class="class-name">class Scope

</div><div class="links"><div class="file">File: <a href="../../../File/Synopsis/SymbolLookup/Scope.hh.html" target="detail">../Synopsis/SymbolLookup/Scope.hh</a></div> <div class="xref"><a href="../../../XRef/xref23.html#Synopsis_mSymbolLookup_mScope" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line66" ><img src="../../../src-c++.png" alt="source code"/></a></div></div>  <img alt="Scope-inheritance" src="Scope-inheritance.png" hspace="8" vspace="8" border="0" usemap="#Scope-inheritance_map" />
<map name="Scope-inheritance_map"><area alt="Scopes/Synopsis/SymbolLookup/FunctionScope.html" href="FunctionScope.html" shape="rect" coords="5, 81, 261, 105" />
<area alt="Scopes/Synopsis/SymbolLookup/Class.html" href="Class.html" shape="rect" coords="285, 81, 485, 105" />
<area alt="Scopes/Synopsis/SymbolLookup/Namespace.html" href="Namespace.html" shape="rect" coords="509, 81, 747, 105" />
<area alt="Scopes/Synopsis/SymbolLookup/LocalScope.html" href="LocalScope.html" shape="rect" coords="771, 81, 1008, 105" />
<area alt="Scopes/Synopsis/SymbolLookup/MultiplyDefined.html" href="MultiplyDefined.html" shape="rect" coords="1032, 81, 1296, 105" />
</map>
 <div class="doc"><p>A Scope contains symbol definitions.</p>
</div>
<!-- this part was generated by Summary -->
<div class="summary">
<div class="heading">Public Typedefs Summary:</div>
<div class="item"><div class="synopsis">SymbolTable::const_iterator <a class="name" id="symbol_iterator">symbol_iterator</a></div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_msymbol_iterator" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line79" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">ScopeTable::const_iterator <a class="name" id="scope_iterator">scope_iterator</a></div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mscope_iterator" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line80" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">unsigned&#160;int <a class="name" id="LookupContext">LookupContext</a></div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mLookupContext" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line82" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;<i>constructor</i> <a class="name" id="Scope_l_r">Scope</a>()  </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mScope_l_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line89" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html" >Scope</a>* <a class="name" id="ref_l_r">ref</a>()  </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mref_l_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line90" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;const&#160;<a href="Scope.html" >Scope</a>* <a class="name" id="ref_l_rconst">ref</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mref_l_rconst" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line91" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="unref_l_rconst">unref</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_munref_l_rconst" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line92" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span> const&#160;<a href="Scope.html" >Scope</a>* <a class="name" id="outer_scope_l_rconst">outer_scope</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mouter_scope_l_rconst" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line94" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;const&#160;<a href="Scope.html" >Scope</a>* <a class="name" id="global_scope_l_rconst">global_scope</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mglobal_scope_l_rconst" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line95" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="accept_lScopeVisitor_S_r">accept</a>(<a href="ScopeVisitor.html" >ScopeVisitor</a>* <span class="variable">v</span>)  </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_maccept_lScopeVisitor_S_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line97" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html#symbol_iterator" >symbol_iterator</a> <a class="name" id="symbols_begin_l_rconst">symbols_begin</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_msymbols_begin_l_rconst" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line99" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html#symbol_iterator" >symbol_iterator</a> <a class="name" id="symbols_end_l_rconst">symbols_end</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_msymbols_end_l_rconst" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line100" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html#scope_iterator" >scope_iterator</a> <a class="name" id="scopes_begin_l_rconst">scopes_begin</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mscopes_begin_l_rconst" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line102" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html#scope_iterator" >scope_iterator</a> <a class="name" id="scopes_end_l_rconst">scopes_end</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mscopes_end_l_rconst" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line103" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Scope.html#declare_lconst.PTree_mEncoding_A_cconst.Symbol_S_r" >declare</a></span>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp; <span class="variable">name</span>, const&#160;<a href="Symbol.html" >Symbol</a>* <span class="variable">symbol</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line107" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare the given symbol in the local scope
using the given encoded name.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_scope_lconst.PTree_mNode_S_cScope_S_r">declare_scope</a>(const&#160;<a href="../PTree/Node.html" >PTree::Node</a>* <span class="variable">node</span>, <a href="Scope.html" >Scope</a>* <span class="variable">scope</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line110" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <span class="name"><a href="Scope.html#use_lconst.PTree_mUsingDirective_S_r" >use</a></span>(const&#160;<a href="../PTree/UsingDirective.html" >PTree::UsingDirective</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line116" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare a 'using' directive.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html" >Scope</a>* <span class="name"><a href="Scope.html#find_scope_lconst.PTree_mNode_S_rconst" >find_scope</a></span>(const&#160;<a href="../PTree/Node.html" >PTree::Node</a>*) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line119" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>find a nested scope by declaration</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html" >Scope</a>* <span class="name"><a href="Scope.html#find_scope_lconst.PTree_mEncoding_A_cconst.Symbol_S_rconst" >find_scope</a></span>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp;, const&#160;<a href="Symbol.html" >Symbol</a>*) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line122" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>find a nested scope by symbol.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Scope.html#remove_scope_lconst.PTree_mNode_S_r" >remove_scope</a></span>(const&#160;<a href="../PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line124" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Remove the given nested scope from the scope.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="../SymbolLookup.html#SymbolSet" >SymbolSet</a> <span class="name"><a href="Scope.html#find_lconst.PTree_mEncoding_A_cLookupContext_rconst" >find</a></span>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="Scope.html#LookupContext" >LookupContext</a>) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line130" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>find the encoded name declared in this scope and
return a set of matching symbols.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Scope.html#remove_lconst.Symbol_S_r" >remove</a></span>(const&#160;<a href="Symbol.html" >Symbol</a>* <span class="variable">s</span>)  </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mremove_lconst.Symbol_S_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line133" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Remove the given symbol from the scope.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="../SymbolLookup.html#SymbolSet" >SymbolSet</a> <span class="name"><a href="Scope.html#lookup_lconst.PTree_mEncoding_A_cLookupContext_rconst" >lookup</a></span>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="Scope.html#LookupContext" >LookupContext</a> = <span class="value">DEFAULT</span>) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line136" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>look up the encoded name and return a set of matching symbols.</p>
</div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span> <a href="../SymbolLookup.html#SymbolSet" >SymbolSet</a> <a class="name" id="unqualified_lookup_lconst.PTree_mEncoding_A_cLookupContext_rconst">unqualified_lookup</a>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="Scope.html#LookupContext" >LookupContext</a> = <span class="value">DEFAULT</span>) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line139" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span> <a href="../SymbolLookup.html#SymbolSet" >SymbolSet</a> <a class="name" id="qualified_lookup_lconst.PTree_mEncoding_A_cLookupContext_rconst">qualified_lookup</a>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="Scope.html#LookupContext" >LookupContext</a> = <span class="value">DEFAULT</span>) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line141" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Data members Summary:</div>
<div class="item"><div class="synopsis">const&#160;<a href="Scope.html#LookupContext" >LookupContext</a> <a class="name" id="DEFAULT">DEFAULT</a> = 0x0</div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mDEFAULT" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line83" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">const&#160;<a href="Scope.html#LookupContext" >LookupContext</a> <a class="name" id="SCOPE">SCOPE</a> = 0x1</div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mSCOPE" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line84" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">const&#160;<a href="Scope.html#LookupContext" >LookupContext</a> <a class="name" id="USING">USING</a> = 0x2</div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mUSING" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line85" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">const&#160;<a href="Scope.html#LookupContext" >LookupContext</a> <a class="name" id="ELABORATE">ELABORATE</a> = 0x4</div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mELABORATE" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line86" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">const&#160;<a href="Scope.html#LookupContext" >LookupContext</a> <a class="name" id="DECLARATION">DECLARATION</a> = 0x8</div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mDECLARATION" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line87" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Protected Typedefs Summary:</div>
<div class="item"><div class="synopsis">std::multimap&lt;<a href="../PTree/Encoding.html" >PTree::Encoding</a>, const&#160;<a href="Symbol.html" >Symbol</a>*&gt; <a class="name" id="SymbolTable">SymbolTable</a></div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mSymbolTable" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line71" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">std::map&lt;const&#160;<a href="../PTree/Node.html" >PTree::Node</a>*, <a href="Scope.html" >Scope</a>*&gt; <a class="name" id="ScopeTable">ScopeTable</a></div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mScopeTable" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line76" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Protected Member functions Summary:</div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;<i>destructor</i> <span class="name"><a href="Scope.html#_tScope_l_r" >~Scope</a></span>()  </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_m_tScope_l_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line146" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Scopes are ref counted, and thus are deleted only by 'unref()'</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Protected Data members Summary:</div>
<div class="item"><div class="synopsis"><a href="Scope.html#SymbolTable" >SymbolTable</a> <a class="name" id="my_symbols">my_symbols</a></div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mmy_symbols" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line148" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="Scope.html#ScopeTable" >ScopeTable</a> <a class="name" id="my_scopes">my_scopes</a></div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mmy_scopes" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line149" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">size_t <a class="name" id="my_refcount">my_refcount</a></div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mmy_refcount" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line150" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<!-- this part was generated by Inheritance -->
<!-- this part was generated by Detail -->
<div class="detail">
<div class="heading">Public Member functions Details:</div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mEncoding_A_cconst.Symbol_S_r">declare</a>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp; <span class="variable">name</span>, const&#160;<a href="Symbol.html" >Symbol</a>* <span class="variable">symbol</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line107" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare the given symbol in the local scope
using the given encoded name.</p>
</div></div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;void <a class="name" id="use_lconst.PTree_mUsingDirective_S_r">use</a>(const&#160;<a href="../PTree/UsingDirective.html" >PTree::UsingDirective</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line116" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare a 'using' directive.
The default implementation raises an exception,
as it is only well-formed when the current scope
is a function scope or a namespace.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html" >Scope</a>* <a class="name" id="find_scope_lconst.PTree_mNode_S_rconst">find_scope</a>(const&#160;<a href="../PTree/Node.html" >PTree::Node</a>*) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line119" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>find a nested scope by declaration</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="Scope.html" >Scope</a>* <a class="name" id="find_scope_lconst.PTree_mEncoding_A_cconst.Symbol_S_rconst">find_scope</a>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp;, const&#160;<a href="Symbol.html" >Symbol</a>*) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line122" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>find a nested scope by symbol.
The encoded name is provided for diagnostic purposes only.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="remove_scope_lconst.PTree_mNode_S_r">remove_scope</a>(const&#160;<a href="../PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line124" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Remove the given nested scope from the scope.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="../SymbolLookup.html#SymbolSet" >SymbolSet</a> <a class="name" id="find_lconst.PTree_mEncoding_A_cLookupContext_rconst">find</a>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="Scope.html#LookupContext" >LookupContext</a>) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line130" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>find the encoded name declared in this scope and
return a set of matching symbols.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="remove_lconst.Symbol_S_r">remove</a>(const&#160;<a href="Symbol.html" >Symbol</a>* <span class="variable">s</span>)  </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_mremove_lconst.Symbol_S_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line133" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Remove the given symbol from the scope.
s shall not be used after its removal.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="../SymbolLookup.html#SymbolSet" >SymbolSet</a> <a class="name" id="lookup_lconst.PTree_mEncoding_A_cLookupContext_rconst">lookup</a>(const&#160;<a href="../PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="Scope.html#LookupContext" >LookupContext</a> = <span class="value">DEFAULT</span>) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line136" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>look up the encoded name and return a set of matching symbols.</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Protected Member functions Details:</div>
<div class="item"><div class="synopsis"><span class="keyword">virtual</span>&#160;<i>destructor</i> <a class="name" id="_tScope_l_r">~Scope</a>()  </div> <div class="xref"><a href="../../../XRef/xref24.html#Synopsis_mSymbolLookup_mScope_m_tScope_l_r" ><img src="../../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../../Source/Synopsis/SymbolLookup/Scope.hh.html#line146" ><img src="../../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Scopes are ref counted, and thus are deleted only by 'unref()'</p>
</div></div>
</div><!-- detail -->

<div class="logo">Generated on Thu Apr 16 16:27:57 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
